SystemOrganization addCategory: #'Seaside-Component'!
SystemOrganization addCategory: #'Seaside-Component-Visitors'!

WAPainterVisitor subclass: #WAInitialRequestVisitor
	instanceVariableNames: 'request'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component-Visitors'!

!WAInitialRequestVisitor class methodsFor: 'instance creation' stamp: 'jf 2/9/2009 16:54'!
new
	^ self request: nil! !

!WAInitialRequestVisitor class methodsFor: 'instance creation' stamp: 'jf 2/9/2009 16:51'!
request: aRequest
	^ self basicNew initializeWithRequest: aRequest; yourself! !

!WAInitialRequestVisitor methodsFor: 'initialization' stamp: 'jf 2/9/2009 16:51'!
initializeWithRequest: aRequest
	self initialize.
	request := aRequest! !

!WAInitialRequestVisitor methodsFor: 'accessing' stamp: 'jf 10/22/2008 12:26'!
request
	^ request! !

!WAInitialRequestVisitor methodsFor: 'visiting' stamp: 'jf 10/22/2008 16:02'!
visitPresenter: aPresenter
	aPresenter initialRequest: self request! !

!WAPainterVisitor methodsFor: '*seaside-component' stamp: 'jf 11/3/2008 13:36'!
visitComponent: aComponent
	self visitPresenter: aComponent! !

!WAPainterVisitor methodsFor: '*seaside-component' stamp: 'jf 10/22/2008 13:18'!
visitDecoration: aDecoration
	self visitPresenter: aDecoration! !

!WAPainterVisitor methodsFor: '*seaside-component' stamp: 'jf 11/3/2008 16:36'!
visitDecorationsOfComponent: aComponent
	aComponent decoration accept: self! !

!WAPainterVisitor methodsFor: '*seaside-component' stamp: 'jf 10/22/2008 10:59'!
visitDelegation: aDelegation
	self visitDecoration: aDelegation! !

!WAPainterVisitor methodsFor: '*seaside-component' stamp: 'jf 10/22/2008 11:02'!
visitPresenter: aPresenter
	self visitPainter: aPresenter! !

WAPainterVisitor subclass: #WAPluggablePresenterVisitor
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component-Visitors'!

!WAPluggablePresenterVisitor class methodsFor: 'instance creation' stamp: 'jf 11/3/2008 16:22'!
block: aBlock
	^ self basicNew initializeWithBlock: aBlock; yourself! !

!WAPluggablePresenterVisitor class methodsFor: 'instance creation' stamp: 'jf 2/9/2009 17:16'!
new
	^ self block: [ :presenter | ]! !

!WAPluggablePresenterVisitor methodsFor: 'accessing' stamp: 'jf 10/22/2008 16:07'!
block
	^ block! !

!WAPluggablePresenterVisitor methodsFor: 'initialization' stamp: 'jf 11/3/2008 16:22'!
initializeWithBlock: aBlock
	self initialize.
	block := aBlock! !

!WAPluggablePresenterVisitor methodsFor: 'visiting' stamp: 'jf 10/22/2008 16:07'!
visitPresenter: aPresenter
	self block value: aPresenter! !

WAPainterVisitor subclass: #WAPresenterGuide
	instanceVariableNames: 'client'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component-Visitors'!

!WAPresenterGuide commentStamp: 'jf 1/31/2009 01:56' prior: 0!
PresenterGuides take another PainterVisitor as a client. When asked to visit a Component, they will first visit its Decorations. Along the way, they will ask their client to visit each Painter they come across.

This allows us to separate the behaviour of the various Presenter-tree traversal methods from the behaviour to perform on each Presenter we visit.!

!WAPresenterGuide class methodsFor: 'instance creation' stamp: 'jf 11/3/2008 15:58'!
client: aPainterVisitor
	^ self basicNew initializeWithClient: aPainterVisitor; yourself! !

!WAPresenterGuide class methodsFor: 'instance creation' stamp: 'jf 2/9/2009 17:18'!
new
	^ self client: WAPainterVisitor new! !

!WAPresenterGuide methodsFor: 'accessing' stamp: 'jf 10/22/2008 14:51'!
client
	^ client! !

!WAPresenterGuide methodsFor: 'initialization' stamp: 'jf 11/3/2008 15:55'!
initializeWithClient: aPainterVisitor
	self initialize.
	client := aPainterVisitor! !

!WAPresenterGuide methodsFor: 'copying' stamp: 'jf 2/12/2009 21:25'!
postCopyForRenderContext: aRenderContext
	super postCopyForRenderContext: aRenderContext.
	client := client copyForRenderContext: aRenderContext! !

!WAPresenterGuide methodsFor: 'visiting' stamp: 'jf 11/3/2008 17:31'!
visit: aPainter
	aPainter acceptDecorated: self! !

!WAPresenterGuide methodsFor: 'visiting' stamp: 'jf 11/3/2008 17:22'!
visitPainter: aPainter
	self client visit: aPainter! !

WAPresenterGuide subclass: #WARenderingGuide
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component-Visitors'!

!WARenderingGuide commentStamp: 'jf 1/31/2009 01:52' prior: 0!
Currently an empty class but still present for clarity and to allow cutomization of Rendering behaviour.!

WAPresenterGuide subclass: #WAVisiblePresenterGuide
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component-Visitors'!

!WAVisiblePresenterGuide commentStamp: 'jf 1/31/2009 01:56' prior: 0!
Visit the tree of all Presenters and their registered #children. Do not visit a Decoration's #next Decoration if the Decoration indicates that it is not visible.!

WAVisiblePresenterGuide subclass: #WAAllPresenterGuide
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component-Visitors'!

!WAAllPresenterGuide commentStamp: 'jf 1/31/2009 01:56' prior: 0!
Visit the tree of all Presenters and their registered #children.!

!WAAllPresenterGuide methodsFor: 'private' stamp: 'jf 11/6/2008 11:47'!
shouldVisitNextPresenterOf: aDecoration
	^ true! !

!WAVisiblePresenterGuide methodsFor: 'private' stamp: 'jf 11/6/2008 11:46'!
shouldVisitNextPresenterOf: aDecoration
	^ aDecoration isDelegation not! !

!WAVisiblePresenterGuide methodsFor: 'visiting' stamp: 'jf 11/6/2008 11:46'!
visitDecoration: aDecoration
	super visitDecoration: aDecoration.
	(self shouldVisitNextPresenterOf: aDecoration)
		ifTrue: [ aDecoration next accept: self ]! !

!WAVisiblePresenterGuide methodsFor: 'visiting' stamp: 'lr 11/4/2008 11:31'!
visitPresenter: aPresenter
	super visitPresenter: aPresenter.
	aPresenter childrenDo: [ :each | self visit: each ]! !

WAPainterVisitor subclass: #WAUpdateStatesVisitor
	instanceVariableNames: 'snapshot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component-Visitors'!

!WAUpdateStatesVisitor class methodsFor: 'instance creation' stamp: 'jf 2/9/2009 16:05'!
new
	^ self snapshot: WASnapshot new! !

!WAUpdateStatesVisitor class methodsFor: 'instance creation' stamp: 'jf 2/9/2009 16:04'!
snapshot: aSnapshot
	^ self basicNew initializeWithSnapshot: aSnapshot; yourself! !

!WAUpdateStatesVisitor methodsFor: 'initialization' stamp: 'jf 2/9/2009 16:05'!
initializeWithSnapshot: aSnapshot
	self initialize.
	snapshot := aSnapshot! !

!WAUpdateStatesVisitor methodsFor: 'accessing' stamp: 'jf 10/22/2008 11:58'!
snapshot
	^ snapshot! !

!WAUpdateStatesVisitor methodsFor: 'visiting' stamp: 'jf 10/22/2008 16:02'!
visitPresenter: aPresenter
	aPresenter updateStates: self snapshot! !

!WAPackage class methodsFor: '*seaside-component' stamp: 'jf 1/27/2009 11:42'!
seasideComponent
	^ self new
		name: 'Seaside-Component';
		description: 'Stateful, reuseable components to encapsulate a small part of a page.';
		addDependency: 'Seaside-Core';
		yourself! !

!WAPainter methodsFor: '*seaside-component' stamp: 'jf 10/22/2008 10:39'!
acceptDecorated: aVisitor
	self accept: aVisitor! !

WAPainter subclass: #WAPresenter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

!WAPresenter commentStamp: 'jf 5/8/2009 00:23' prior: 0!
WAPresenter holds the functionality that is common to WAComponent and WADecoration. Subclasses of this class may have state and can be stored in instance variables of other Presenters.

You might want to subclass WAPresenter if you do not need the special abilities (decoration and call/answer) of WAComponent but do need one or more of the following:

	+ The ability to specify objects whose state should be backtracked (#states)
	+ The ability to provide CSS and JavaScript for the component (#style, #script)
	+ The ability to "embed" other persistent Presenters within this one (#children)

WAPresenter does not support call/answer or the addition of Decorations. If you need either of these features, you should subclass WAComponent instead.

Child Presenters:
It is common for a Presenter to display instances of other Presenters while rendering itself.  It does this by passing them into the #render: method of a renderer (typically an instance of WACanvas).  For example, this #renderContentOn: method simply renders a heading and then displays a counter component 
immediately below it:

	renderContentOn: html
		html heading level3; with: 'My Counter'.
		html render: myCounter.

It's important that you use #render:, rather than directly calling the #renderContentOn: method of the subcomponent. The following is *not* correct:

	renderContentOn: html
		html heading level3; with: 'My Counter'.
		myCounter renderContentOn: html.   "DON'T DO THIS".

These sub-Presenters are usually instance variables of the Presenter that is "embedding" them.  They are commonly created as part of the Presenter's #initialize method:

	initialize
		myCounter := WACounter new.

They may also be stored in a collection. One fairly common pattern is to keep a lazily initialized dictionary of sub-presenters that match a collection of model items. For example, if you wanted a BudgetItemRow subcomponent for each member of budgetItems, you might do something like this:

	initialize
		budgetRows := Dictionary new.

	rowForItem: anItem
		^budgetRows at: anItem ifAbsentPut: [ BudgetItemRow item: anItem ].

	renderContentOn: html
		self budgetItems
			do: [ :each | html render: (self rowForItem: each) ]
			separatedBy: [ html horizontalLine ].

Each parent Presenter *must* implement a #children method that returns a collection of all of the sub-Presenters that it might display on the next render. For the above two examples, #children might look like this:

	children
		^Array with: myCounter

or this:

	children
		^self budgetItems collect: [ :each | self rowForItem: each ].
		
Visibility:
A Presenter is visible if it is:
- the root of an application
- a child of a visible Presenter (returned by #children) that has not been #call:'d!

WAPresenter subclass: #WAComponent
	instanceVariableNames: 'decoration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

!WAComponent commentStamp: 'jf 11/3/2008 20:52' prior: 0!
I am a Presenter with the additional abilities of wrapping myself with Decorations and displaying another Component with #call:.
		
Call/Answer:
If a sub-Component makes a #call: to another Component, that Component will appear in place of the sub-Component.  For example, if an embedded WACounter, stored in an instance variable called myCounter, made a #call: to DateSelector, that DateSelector would appear in the context of the counter's parent, with the 'My Counter' heading above it.

Since an embedded subcomponent has not been #call:'d, in general #answer: is a no-op.  However, the parent may attach an #onAnswer: block to the embedded subcomponent to be notified if it sends #answer:. This allows one component to be used both from #call: and through embedding. For example:

	initialize
		dateSelector := WADateSelector new 
			onAnswer: [ :date | self dateChosen: date ].
			
Visibility:
A component is visible if it:
- meets the visibility requirements of a Presenter; or
- is passed as an argument to #call: on a visible component!

!WAComponent class methodsFor: 'testing' stamp: 'lr 10/28/2007 14:42'!
canBeRoot
	"When returning true, the component can be registered as a standalone application from the config interface."

	^ false! !

!WAComponent class methodsFor: 'accessing' stamp: 'lr 2/12/2007 23:15'!
description
	^ self name! !

!WAComponent methodsFor: 'visiting' stamp: 'jf 10/22/2008 09:18'!
accept: aVisitor
	aVisitor visitComponent: self! !

!WAComponent methodsFor: 'visiting' stamp: 'jf 11/3/2008 16:34'!
acceptDecorated: aVisitor
	aVisitor visitDecorationsOfComponent: self! !

!WAComponent methodsFor: 'convenience' stamp: 'lr 11/4/2008 10:04'!
activeComponent
	"Answer the visible component, this might be a different component being delegated to or the receiver itself."
	
	self visiblePresentersDo: [ :each | each isDecoration ifFalse: [ ^ each ] ]! !

!WAComponent methodsFor: 'decorations' stamp: 'lr 2/28/2009 22:39'!
addDecoration: aDecoration
	| previous current |
	previous := nil.
	current := self decoration.
	[ current ~~ self and: [ self decoration: current shouldWrap: aDecoration ] ] whileTrue: [
		previous := current.
		current := current next ].
	aDecoration setNext: current.
	previous isNil
		ifTrue: [ self decoration: aDecoration ]
		ifFalse: [ previous setNext: aDecoration ].
	^ aDecoration! !

!WAComponent methodsFor: 'deprecated' stamp: 'lr 3/14/2009 09:31'!
allDecorationsDo: aBlock
	| ea |
	self 
		seasideDeprecatedApi: 'WAComponent>>#allDecorationsDo:'
		details: 'Use aComponent decorations do: [ :each | ... ].'.
	ea := self decoration.
	[ea notNil and: [ea ~~ self]] whileTrue:
		[aBlock value: ea.
		ea := ea next]! !

!WAComponent methodsFor: 'delegation' stamp: 'avi 3/27/2004 00:55'!
answer
	self answer: self! !

!WAComponent methodsFor: 'delegation' stamp: 'jf 10/22/2008 13:26'!
answer: anObject
	"Give back control back to the component from which the receiver was called.
	When returning, a component can additionally return anObject to the caller."

	self decoration handleAnswer: anObject! !

!WAComponent methodsFor: 'decorations' stamp: 'lr 9/13/2008 17:14'!
component
	^ self! !

!WAComponent methodsFor: 'decorations' stamp: 'avi 3/27/2004 19:53'!
decorateWith: aDecoration during: aBlock
	| val |
	self addDecoration: aDecoration.
	val := aBlock value.
	self removeDecoration: aDecoration.
	^ val! !

!WAComponent methodsFor: 'accessing' stamp: 'lr 4/15/2007 18:48'!
decoration
	^ decoration contents! !

!WAComponent methodsFor: 'accessing' stamp: 'avi 9/22/2004 13:59'!
decoration: aDecoration
	decoration contents: aDecoration! !

!WAComponent methodsFor: 'decorations' stamp: 'avi 3/28/2004 20:49'!
decoration: oldDecoration shouldWrap: newDecoration
	^ (oldDecoration isGlobal and: [newDecoration isGlobal not])
		or: [oldDecoration isDelegation and: [newDecoration isLocal]]! !

!WAComponent methodsFor: 'accessing' stamp: 'lr 3/14/2009 09:10'!
decorations
	"Answer an ordered colleciton of all decorations active in the receiver."
	
	| current result |
	current := self decoration.
	result := OrderedCollection new.
	[ current = self ] whileFalse: [
		result add: current.
		current := current next ].
	^ result! !

!WAComponent methodsFor: 'accessing' stamp: 'lr 3/14/2009 09:11'!
delegations
	"Answer an ordered colleciton of all delections active in the receiver."
	
	^ self decorations select: [ :each | each isDelegation ]! !

!WAComponent methodsFor: 'accessing' stamp: 'lr 11/4/2008 10:03'!
home
	"Remove all delegations from the receiver, making sure that it is displayed again."
	
	self delegations do: [ :each | self removeDecoration: each ]! !

!WAComponent methodsFor: 'initialization' stamp: 'jf 2/9/2009 16:59'!
initialize
	super initialize.
	decoration := WAValueHolder with: self! !

!WAComponent methodsFor: 'delegation' stamp: 'lr 10/28/2007 14:42'!
onAnswer: aBlock
	"Adds an answer handler aBlock to the receiver."

	^ self addDecoration: (WAAnswerHandler new block: aBlock)! !

!WAComponent methodsFor: 'decorations' stamp: 'jf 9/17/2009 13:50'!
removeDecoration: aDecoration
	| dec |
	dec := self decoration.
	dec = aDecoration ifTrue:
		[self decoration: dec next.
		^ self].

	[dec notNil and: [ dec isDecoration ]] whileTrue:
		[dec next = aDecoration
			ifTrue: [dec setNext: aDecoration next.  ^ self]
			ifFalse: [dec := dec next]]! !

!WAComponent methodsFor: 'delegation' stamp: 'lr 10/28/2007 14:42'!
show: aComponent
	"Pass control from the receiver to aComponent. The receiver will be temporarily replaced with aComponent. As opposed to #call: sending this message does not block and immediately returns."

	self
		show: aComponent
		onAnswer: [ :value | ]! !

!WAComponent methodsFor: 'delegation' stamp: 'lr 10/28/2007 14:42'!
show: aComponent onAnswer: aBlock
	"Pass control from the receiver to aComponent. The receiver will be temporarily replaced with aComponent. When #answer: is sent to aComponent, aBlock is evaluated. This can be used for continuation passing style programmation of a control flow. #show:onAnswer: does not block."

	self
		show: aComponent
		onAnswer: aBlock
		delegation: (WADelegation new
			delegate: aComponent;
			yourself)! !

!WAComponent methodsFor: 'delegation' stamp: 'jf 9/17/2009 15:27'!
show: aComponent onAnswer: aBlock delegation: aDelegation
	| event |
	event := nil.
	event := aComponent onAnswer: [ :value |
		aDelegation remove.
		event remove.
		aBlock valueWithPossibleArguments: (Array with: value) ].
	self addDecoration: aDelegation! !

!WAComponent methodsFor: 'updating' stamp: 'lr 4/20/2007 20:18'!
updateStates: aSnapshot
	super updateStates: aSnapshot.
	aSnapshot register: decoration! !

WAPresenter subclass: #WADecoration
	instanceVariableNames: 'next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

!WADecoration commentStamp: 'jf 10/19/2008 03:56' prior: 0!
I am an abstract decoration around instances of WAComponent. I can be added to aComponent by calling #addDecoration: and I change the basic behaviour or look of a component. There are several methods that can be overriden to archive this:

- #renderContentOn: to emit xhtml around the decorated component. Call #renderOwnerOn: to let the owner emit its output.

- #handleAnswer: to intercept the answer processing.!

WADecoration subclass: #WAAnswerHandler
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

!WAAnswerHandler methodsFor: 'accessing' stamp: 'avi 6/2/2004 21:59'!
block: aBlock
	block := aBlock! !

!WAAnswerHandler methodsFor: 'delegation' stamp: 'pmm 1/10/2009 22:59'!
handleAnswer: anObject continueWith: aBlock
	block valueWithPossibleArguments: (Array with:  anObject)! !

!WADecoration class methodsFor: 'testing' stamp: 'lr 9/14/2008 12:54'!
canBeRoot
	^ false! !

!WADecoration methodsFor: 'visiting' stamp: 'jf 10/22/2008 09:19'!
accept: aVisitor
	aVisitor visitDecoration: self! !

!WADecoration methodsFor: 'deprecated' stamp: 'lr 10/22/2008 22:31'!
asComponent
	self 
		seasideDeprecatedApi: 'WADecoration>>#asComponent'
		details: 'Use WADecoration>>#component.'.
	^ self component! !

!WADecoration methodsFor: 'accessing' stamp: 'lr 9/13/2008 17:05'!
component
	"Answer the owning component."

	^ self next component! !

!WADecoration methodsFor: 'delegation' stamp: 'lr 9/13/2008 17:13'!
handleAnswer: anObject
	(self next handleAnswer: anObject) ifFalse:
		[self handleAnswer: anObject continueWith: [^ false]].
	^ true! !

!WADecoration methodsFor: 'processing' stamp: 'avi 6/22/2004 11:03'!
handleAnswer: anObject continueWith: aBlock
	aBlock value! !

!WADecoration methodsFor: 'initialization' stamp: 'lr 9/5/2007 11:21'!
initialize
	super initialize.
	next := WAValueHolder new! !

!WADecoration methodsFor: 'testing' stamp: 'avi 3/27/2004 19:55'!
isDecoration
	^ true! !

!WADecoration methodsFor: 'testing' stamp: 'jf 11/6/2008 11:48'!
isDelegation
	"If #isDelegation is true, we do not want our 'next' presenter to be displayed."
	^ false! !

!WADecoration methodsFor: 'testing' stamp: 'avi 3/28/2004 20:48'!
isGlobal
	^ false! !

!WADecoration methodsFor: 'testing' stamp: 'avi 3/28/2004 20:49'!
isLocal
	^ (self isGlobal or: [self isDelegation]) not! !

!WADecoration methodsFor: 'accessing' stamp: 'lr 9/13/2008 17:03'!
next
	"Answer the next decoration or component."

	^ next contents! !

!WADecoration methodsFor: 'deprecated' stamp: 'lr 12/30/2008 12:48'!
owner
	self
		seasideDeprecatedApi: 'WADecoration>>#owner'
		details: 'Use WADecoration>>#next or WADecoration>>#component.'.
	^ next contents! !

!WADecoration methodsFor: 'actions' stamp: 'jf 11/4/2008 11:54'!
remove
	"Remove the decoration from the owning component."
	
	self component removeDecoration: self! !

!WADecoration methodsFor: 'rendering' stamp: 'jf 10/22/2008 10:10'!
renderContentOn: html
	self renderNextOn: html! !

!WADecoration methodsFor: 'rendering' stamp: 'jf 10/22/2008 10:28'!
renderNextOn: html
	self next renderUndecoratedWithContext: html context! !

!WADecoration methodsFor: 'deprecated' stamp: 'lr 12/30/2008 12:48'!
renderOwnerOn: html
	self 
		seasideDeprecatedApi: 'WADecoration>>#renderOwnerOn:'
		details: 'Use renderNextOn:.'.
	self renderNextOn: html! !

!WADecoration methodsFor: 'initialization' stamp: 'lr 9/13/2008 17:03'!
setNext: aDecoration
	next contents: aDecoration! !

!WADecoration methodsFor: 'updating' stamp: 'lr 4/20/2007 20:18'!
updateStates: aSnapshot
	super updateStates: aSnapshot.
	aSnapshot register: next! !

WADecoration subclass: #WADelegation
	instanceVariableNames: 'delegate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

!WADelegation methodsFor: 'visiting' stamp: 'jf 10/22/2008 10:15'!
accept: aVisitor
	aVisitor visitDelegation: self! !

!WADelegation methodsFor: 'hooks' stamp: 'lr 11/4/2008 11:45'!
children
	^ Array with: self delegate! !

!WADelegation methodsFor: 'accessing' stamp: 'avi 3/12/2004 20:18'!
delegate
	^ delegate! !

!WADelegation methodsFor: 'accessing' stamp: 'avi 3/12/2004 20:18'!
delegate: aComponent
	delegate := aComponent! !

!WADelegation methodsFor: 'testing' stamp: 'avi 3/27/2004 22:26'!
isDelegation
	^ true! !

!WADelegation methodsFor: 'rendering' stamp: 'lr 11/4/2008 11:58'!
renderContentOn: html
	html render: self delegate! !

!WAPresenter methodsFor: 'visiting' stamp: 'jf 10/22/2008 11:02'!
accept: aVisitor
	aVisitor visitPresenter: self! !

!WAPresenter methodsFor: 'convenience' stamp: 'jf 2/13/2009 14:46'!
allPresentersDo: aBlock
	(WAAllPresenterGuide client:
		(WAPluggablePresenterVisitor block: aBlock))
		start: self! !

!WAPresenter methodsFor: 'hooks' stamp: 'jf 11/3/2008 13:53'!
children
	"This method is really important. It should return a collection of all sub-presenters that will (or might) be rendered in #renderContentOn:. Components that are displayed using #call: are *not* children.

	If the contents returned by this method change over time make sure to return them in #states as well, otherwise the back button will fail."

	^ #()! !

!WAPresenter methodsFor: 'iterating' stamp: 'lr 2/28/2009 22:39'!
childrenDo: aBlock
	self children do: [ :each | 
		each isNil
			ifFalse: [ aBlock value: each ] ]! !

!WAPresenter methodsFor: 'decorations' stamp: 'lr 9/4/2009 09:44'!
component
	"Answer the owning component."

	^ nil! !

!WAPresenter methodsFor: 'delegation' stamp: 'jf 10/21/2008 22:15'!
handleAnswer: anObject
	^ false! !

!WAPresenter methodsFor: 'hooks' stamp: 'lr 10/28/2007 14:42'!
initialRequest: aRequest
	"When a new session is started, all visible presenters (components or tasks) receive this message with the request as argument.

	A common usage for this is to initialize their state depending on the URL of the request. This is one building block for bookmarkable URL. The other is updateUrl: where you can manipulate the anchor urls generated by Seaside.

	You can not use #call: in here. Consider using a WATask instead and sending #call: in #go.

	See WABrowser for examples."! !

!WAPresenter methodsFor: 'testing' stamp: 'avi 3/27/2004 19:55'!
isDecoration
	^ false! !

!WAPresenter methodsFor: 'rendering' stamp: 'jf 9/9/2009 19:21'!
renderContentOn: aRenderer
	"By default, render all our children in order. Presenters should override this method
	to specify how they should render themselves. By convention, implementations of this
	method that expect a Canvas renderer use 'html' as the parameter name.
	See also #rendererClass."
	
	self childrenDo: [ :each | aRenderer render: each ]! !

!WAPresenter methodsFor: 'rendering' stamp: 'jf 2/13/2009 19:21'!
renderUndecoratedWithContext: aRenderContext
	"Render ourselves directly on aRenderer without allowing our Decorations to be visited."
	
	self accept: aRenderContext visitor! !

!WAPresenter methodsFor: 'hooks' stamp: 'pmm 4/7/2007 17:16'!
script
	"The same as #style except that it is for JavaScript. This is rarely used, consider using WAFileLibrary or exernal files instead."
	^ nil! !

!WAPresenter methodsFor: 'hooks' stamp: 'lr 10/28/2007 14:42'!
states
	"Answer a collection of states that should be backtracked."

	^ #()! !

!WAPresenter methodsFor: 'hooks' stamp: 'lr 10/28/2007 14:42'!
style
	"Returns a CSS stylesheet associated with this component. This stylesheet will be added to <head> section of the html document so it will be global and not scoped.

	This is done for all visible components (see class comment of WAComponent for what visible means).

	Nice for demos but consider using WAFileLibrary or exernal files instead."

	^ nil! !

!WAPresenter methodsFor: 'updating' stamp: 'lr 9/8/2009 12:40'!
updateRoot: anHtmlRoot
	"This method allows you customize the <head> section of an HTML document. The API is very similar to the 'Canvas API' for rendering in the <body> section (where you 'draw' in #renderContentOn:).

	anHtmlRoot is an instance of WAHtmlRoot

	Whenever you override this method don't forget to send super"
	super updateRoot: anHtmlRoot.

	self script isNil ifFalse: [ anHtmlRoot addScript: self script ].
	self style isNil ifFalse: [ anHtmlRoot addStyle: self style ]! !

!WAPresenter methodsFor: 'updating' stamp: 'lr 10/28/2007 14:42'!
updateStates: aSnapshot
	"This method allows to register objects for backtracking. Don't forget to send super in all cases."

	self states do: [ :each | aSnapshot register: each ]! !

!WAPresenter methodsFor: 'convenience' stamp: 'jf 2/12/2009 20:54'!
visiblePresentersDo: aBlock
	(WAVisiblePresenterGuide client:
		(WAPluggablePresenterVisitor block: aBlock))
		start: self! !
